ConfigMLInterpreterProxy subclass: #DTSWithClassesMLProxy
	instanceVariableNames: ''
	classVariableNames: 'SelectorsDictionary '
	poolDictionaries: ''
	category: 'Thesis-DTS with Classes'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DTSWithClassesMLProxy class
	instanceVariableNames: ''!

!DTSWithClassesMLProxy class methodsFor: 'accessing' stamp: 'HAW 5/8/2000 11:50'!
selectorsDictionary

	^SelectorsDictionary! !


!DTSWithClassesMLProxy class methodsFor: 'initialization' stamp: 'HAW 5/8/2001 09:34'!
initializeInterpreter

	"Assumes that SelectorsDictionary has the right values"
	ConfigMLInterpreterProxy runPrimitiveMessageToMethodLookupStrategy: #setSelectorsDictionary: with: self selectorsDictionary.
! !

!DTSWithClassesMLProxy class methodsFor: 'initialization' stamp: 'HAW 6/10/2001 19:24'!
initializeSelectorsDictionary

	| selector method selectorDictionary |
	SelectorsDictionary _ IdentityDictionary new.
	Smalltalk allBehaviorsDo: 
		[:aBehavior |
		aBehavior methodDictionary associationsDo:
			[:anAssoc |
			selector _ anAssoc key.
			method _ anAssoc value.
			selectorDictionary _ SelectorsDictionary at: selector ifAbsent: 
				[ SelectorsDictionary at: selector put: IdentityDictionary new.].
			selectorDictionary at: aBehavior put: method.
			].
		].

	SelectorsDictionary rehash.
	SelectorsDictionary do: [ :aDictionary | aDictionary rehash ].
	Smalltalk garbageCollect.
! !


!DTSWithClassesMLProxy class methodsFor: 'statistics' stamp: 'HAW 7/19/2001 10:14'!
dtsDictionariesSize

	|  allBehaviors |

	allBehaviors _ Object allSubclasses 
		add: Object;
		yourself.
	^allBehaviors asOrderedCollection collect: [ :aBehavior | aBehavior methodDictionary size. ].
! !

!DTSWithClassesMLProxy class methodsFor: 'statistics' stamp: 'HAW 7/19/2001 10:12'!
dtsWithClassesDictionariesSizes

	^self selectorsDictionary collect: [ :aSelectorDictionary | aSelectorDictionary size. ].
! !

!DTSWithClassesMLProxy class methodsFor: 'statistics' stamp: 'HAW 7/19/2001 10:33'!
printStatistics

	Transcript 
		show: DTSWithClassesMLProxy dtsDictionariesSize average asFloat printString; cr;
		show: DTSWithClassesMLProxy dtsWithClassesDictionariesSizes average asFloat printString; cr;
		show: DTSWithClassesMLProxy dtsDictionariesSize max asFloat  printString; cr;
		show: DTSWithClassesMLProxy dtsWithClassesDictionariesSizes max asFloat  printString; cr;
		show: DTSWithClassesMLProxy dtsDictionariesSize min asFloat printString; cr;
		show: DTSWithClassesMLProxy dtsWithClassesDictionariesSizes min asFloat printString; cr;
		show: DTSWithClassesMLProxy dtsDictionariesSize median asFloat  printString; cr;
		show: DTSWithClassesMLProxy dtsWithClassesDictionariesSizes median asFloat   printString; cr.! !
