Object subclass: #FullDictionaryML
	instanceVariableNames: ''
	classVariableNames: 'FullDictionaries OriginalMethodDictionaries '
	poolDictionaries: ''
	category: 'Thesis-Full Dictionary'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FullDictionaryML class
	instanceVariableNames: ''!

!FullDictionaryML class methodsFor: 'Full Dictionary Creation' stamp: 'HAW 6/19/2001 10:19'!
createFullDictionaryFor: aBehavior

	| fullDictionary |
	fullDictionary _ MethodDictionary new.
	aBehavior allSelectors do: [ :aSelector |
		fullDictionary at: aSelector put: (aBehavior lookupSelector: aSelector ) ].

	fullDictionary rehash.
	^fullDictionary.! !


!FullDictionaryML class methodsFor: 'test' stamp: 'HAW 6/19/2001 10:28'!
test

	|vtbl |

	FullDictionaries keysDo: [ :aBehavior |
		vtbl _ FullDictionaries at: aBehavior.
		aBehavior allSelectors do: [ :aSelector |
			(aBehavior lookupSelector: aSelector)==(vtbl at: aSelector) ifFalse: [
				self error: 'Test failed'. ].
		].
	].

	^true.! !


!FullDictionaryML class methodsFor: 'method lookup selection' stamp: 'HAW 7/18/2001 10:10'!
selectDTS

	OriginalMethodDictionaries keysDo: [ :aBehavior |
		aBehavior recreateMethodDictionary. ].! !

!FullDictionaryML class methodsFor: 'method lookup selection' stamp: 'HAW 6/19/2001 10:21'!
selectFullDictionary

	FullDictionaries keysDo: [ :aBehavior |
		aBehavior methodDictionary: (FullDictionaries at: aBehavior). ].! !


!FullDictionaryML class methodsFor: 'initialize' stamp: 'HAW 6/19/2001 10:23'!
initializeFor: aCollectionOfSuperclasses

	self initializeOriginalMethodDictionaries: aCollectionOfSuperclasses.
	self initializeFullDictionaries: aCollectionOfSuperclasses.! !

!FullDictionaryML class methodsFor: 'initialize' stamp: 'HAW 6/19/2001 10:23'!
initializeFullDictionaries: aCollectionOfSuperclasses

	FullDictionaries _ Dictionary new.
	aCollectionOfSuperclasses do: [ :aSuperclass |
		FullDictionaries at: aSuperclass put: (self createFullDictionaryFor: aSuperclass ).		
		aSuperclass allSubclasses do: [ :aBehavior |
			FullDictionaries at: aBehavior put: (self createFullDictionaryFor: aBehavior ). ]. ].	! !

!FullDictionaryML class methodsFor: 'initialize' stamp: 'HAW 6/17/2001 22:57'!
initializeOriginalMethodDictionaries: aCollectionOfSuperclasses

	OriginalMethodDictionaries _ Dictionary new.
	aCollectionOfSuperclasses do: [ :aSuperclass |
		OriginalMethodDictionaries at: aSuperclass put: aSuperclass methodDictionary.		
		aSuperclass allSubclasses do: [ :aBehavior |
			OriginalMethodDictionaries at: aBehavior put: aBehavior methodDictionary. ]. ].! !


!FullDictionaryML class methodsFor: 'statistics' stamp: 'HAW 7/31/2001 09:07'!
numberOfDTSEntries

	self selectDTS.
	^OriginalMethodDictionaries keys inject: 0 into: [ :aNumber :aBehavior |
		aNumber _ aNumber + aBehavior methodDictionary size. ].
	! !

!FullDictionaryML class methodsFor: 'statistics' stamp: 'HAW 7/31/2001 09:08'!
numberOfFullDictionaryEntries

	| number |
	self selectFullDictionary.
	number _ OriginalMethodDictionaries keys inject: 0 into: [ :aNumber :aBehavior |
		aNumber _ aNumber + aBehavior methodDictionary size. ].
	self selectDTS.

	^number.
	! !
