Object subclass: #ClassInterval
	instanceVariableNames: 'from to '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Hierarchy Branch'!

!ClassInterval methodsFor: 'partitionate' stamp: 'HAW 5/17/2001 15:48'!
partitionateUsing: aClassInterval

	| currentTo newInterval |
	currentTo _ self to.
	self to: (aClassInterval from).
	(currentTo=aClassInterval to) ifTrue: [
		newInterval _ nil. ]
	ifFalse: [
		newInterval _ self shallowCopy.
		newInterval from: (aClassInterval to);
			to: currentTo.
	].
	^newInterval.

! !


!ClassInterval methodsFor: 'testing' stamp: 'HAW 5/22/2001 09:40'!
includes: aNumberOrClassNumbers
	"Verifies that the range of numbers in aClassNumbers are between the range of self.
	 It is inclusive"

	(aNumberOrClassNumbers isKindOf: Number ) ifTrue: [
		^(self from<=aNumberOrClassNumbers) and: [ self to>aNumberOrClassNumbers ].]
	ifFalse: [
		^(self from<=aNumberOrClassNumbers from) and: [ self to>=aNumberOrClassNumbers to ].].! !


!ClassInterval methodsFor: 'accessing' stamp: 'HAW 1/25/2000 17:03'!
from
	^from! !

!ClassInterval methodsFor: 'accessing' stamp: 'HAW 1/25/2000 17:03'!
from: aNumber
	from _ aNumber! !

!ClassInterval methodsFor: 'accessing' stamp: 'HAW 1/25/2000 17:03'!
to
	^to! !

!ClassInterval methodsFor: 'accessing' stamp: 'HAW 1/25/2000 17:03'!
to: aNumber
	to _ aNumber! !


!ClassInterval methodsFor: 'printing' stamp: 'HAW 1/25/2000 18:02'!
printOn: aStream

	aStream nextPutAll: 'From: '.
	self from printOn: aStream.
	aStream nextPutAll: ' To: '.
	self to printOn: aStream.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassInterval class
	instanceVariableNames: ''!

!ClassInterval class methodsFor: 'instance creation' stamp: 'HAW 1/25/2000 17:57'!
from: from to: to

	^super new
		from: from;
		to: to.! !


Object subclass: #HierarchyBranchML
	instanceVariableNames: ''
	classVariableNames: 'ClassIntervals SelectorImplementations '
	poolDictionaries: ''
	category: 'Thesis-Hierarchy Branch'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HierarchyBranchML class
	instanceVariableNames: ''!

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 6/10/2001 19:14'!
createSelectorImplementations

	| allSelectorsImplementations selector method aBehaviorInterval implementationIntervals |

	allSelectorsImplementations _ Dictionary new.
	Smalltalk allBehaviorsDo: 
		[ :aBehavior |
		aBehaviorInterval := self classIntervalFor: aBehavior.
		aBehavior methodDictionary associationsDo:
			[ :association |
			selector _ association key.
			method _ association value.
			implementationIntervals _ allSelectorsImplementations at: selector ifAbsent: 
				[implementationIntervals _ SortedCollection sortBlock: [ :a :b | 
					(a from < b from) or: [ a from=b from and: [ a to<=b to ] ].].
				allSelectorsImplementations at: selector put: implementationIntervals. ].
			implementationIntervals add: 
				(MessageImplementationBranch classInterval: aBehaviorInterval
				method: method). ].
		].

	self reorderAllImplementations: allSelectorsImplementations.
	allSelectorsImplementations rehash.
	^allSelectorsImplementations.! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 6/10/2001 19:26'!
reorderAllImplementations: aDictionary

"	self halt.
	self reorderImplementations: (aDictionary at: #newFrom:)."

	aDictionary associationsDo: [ :anAssociation |
		"Transcript show: anAssociation key; cr."
		self reorderImplementations: anAssociation value. ].

			! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/17/2001 16:20'!
reorderEqualFrom: messageImplementationA  b: messageImplementationB collection: aSortedCollection addedCollection: addedCollection

	"The only reason why there are to intervals with the same from is because one
	is the product of a reordering"
	(addedCollection includes: messageImplementationA) ifTrue: [
		"If the smallest o equal interval was the added, just remove it becuase its method it is not
		the right one. The right one is the original."
		aSortedCollection remove: messageImplementationA.]
	ifFalse: [
		(addedCollection includes: messageImplementationB) ifTrue: [
			aSortedCollection remove: messageImplementationB.
			"Now I have to verify is there is some classes that still have the method referenced by
			messageImplementationB"
			(messageImplementationA to<messageImplementationB to) ifTrue: [
				messageImplementationB from: (messageImplementationA to).
				aSortedCollection add: messageImplementationB.]
			ifFalse: [
				(messageImplementationA to>messageImplementationB to) ifTrue: [
					self error: 'Error en algoritmo de reordenamiento'. ].
			].				
		]
		ifFalse: [ 
				self error: 'Error en algoritmo de reordenamiento'
		].
	].

			
! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/17/2001 16:28'!
reorderImplementations: aSortedCollection

	| index messageImplementationA messageImplementationB messageImplementationC originalCollection addedCollection |

	originalCollection _ aSortedCollection species sortBlock: (aSortedCollection sortBlock).
	aSortedCollection do: [ :anObject | originalCollection add: (anObject shallowCopy). ].
	addedCollection _ OrderedCollection new.

	index _ 1.
	[index < aSortedCollection size] whileTrue: [
		messageImplementationA _ aSortedCollection at: index.
		messageImplementationB _ aSortedCollection at: (index + 1).
		"two from can only be equal after breaking an interval"
		(messageImplementationA from=messageImplementationB from) ifTrue: [
			"The to can be equal or less than because of the order"
			self reorderEqualFrom: messageImplementationA  b: messageImplementationB collection: aSortedCollection addedCollection: addedCollection.
		]
		ifFalse: [
			(messageImplementationA includes: messageImplementationB) ifTrue: [
				messageImplementationC _ messageImplementationA 
					partitionateUsing: messageImplementationB.
				messageImplementationC isNil ifFalse: [ 
					aSortedCollection add: messageImplementationC.
					addedCollection add: messageImplementationC.].
			].
		index _ index + 1.
		].
	].

	self unifyContinuousIntervals: aSortedCollection.
	self reorderImplementationsPostCondition: aSortedCollection original: originalCollection addedCollection: addedCollection.
! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/22/2001 09:02'!
reorderImplementationsPostCondition: aSortedCollection original: anOriginalCollection addedCollection: addedCollection
	"This method verifies if the reordering was done ok. Just for test."

	| index messageImplementationA messageImplementationB |

	index _ 1.
	[index < aSortedCollection size] whileTrue: [
		messageImplementationA _ aSortedCollection at: index.
		messageImplementationB _ aSortedCollection at: (index + 1).
		messageImplementationA to=messageImplementationB from ifTrue: [
			messageImplementationA method==messageImplementationB method ifTrue: [
				self error: 'Error en el algoritmo de reordenamiento'. ].
		]
		ifFalse: [
			messageImplementationA to>messageImplementationB from ifTrue: [
				self error: 'Error en el algoritmo de reordenamiento'. ].
		].

		index _ index + 1.
	].

! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/15/2001 10:06'!
selectorImplementations

	^SelectorImplementations! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/17/2001 10:30'!
selectorImplementations: aDictionary

	SelectorImplementations _ aDictionary.! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/22/2001 09:35'!
selectorImplementationsFor: aSelector

	^self selectorImplementations at: aSelector! !

!HierarchyBranchML class methodsFor: 'selector implementations' stamp: 'HAW 5/22/2001 08:54'!
unifyContinuousIntervals: aSortedCollection

	| index messageImplementationsA messageImplementationsB |

	index _ 1.
	[index < aSortedCollection size] whileTrue: [
		messageImplementationsA _ aSortedCollection at: index.
		messageImplementationsB _ aSortedCollection at: index+1.
		((messageImplementationsA to=messageImplementationsB from) and: [
		messageImplementationsA method==messageImplementationsB method]) ifTrue: [
			messageImplementationsA to: messageImplementationsB to.
			aSortedCollection remove: messageImplementationsB. ]
		ifFalse: [
			index _ index + 1. ].
	].
! !


!HierarchyBranchML class methodsFor: 'initialization' stamp: 'HAW 6/10/2001 19:24'!
initialize

	self initializeClassIntervals.
	self initializeSelectorImplementations.
	Smalltalk garbageCollect.
! !

!HierarchyBranchML class methodsFor: 'initialization' stamp: 'HAW 3/4/2000 15:32'!
initializeClassIntervals

	ClassIntervals _ self createClassIntervals.
! !

!HierarchyBranchML class methodsFor: 'initialization' stamp: 'HAW 5/17/2001 10:57'!
initializeSelectorImplementations

	SelectorImplementations _ self createSelectorImplementations.
! !


!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 5/22/2001 08:59'!
behaviorFor: aNumber

	self classIntervals associationsDo: [ :anAssociation |
		anAssociation value from=aNumber ifTrue: [ ^anAssociation key ].
	].

	^nil.! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 5/29/2001 13:05'!
classFor: aClassNumber 

	^self classFor: aClassNumber ifAbsent: [self error: 'Clase no encontrada'].! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 5/29/2001 12:49'!
classFor: aClassNumber ifAbsent: aBlock

	ClassIntervals associationsDo: [ :assoc |
		(aClassNumber=assoc value from) ifTrue: [
			^assoc key. ].
	].

	^aBlock value.! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 3/4/2000 15:28'!
classIntervalFor: aBehavior

	^ClassIntervals at: aBehavior! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 3/22/2000 17:10'!
classIntervals

	^ClassIntervals! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 5/17/2001 10:29'!
classIntervals: aDictionary

	ClassIntervals _ aDictionary! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 6/10/2001 19:14'!
createClassIntervals

	| classIntervals |

	classIntervals _ IdentityDictionary new.
	self numerateClassesFrom: Object startingWith: 1 on: classIntervals.
	classIntervals rehash.
	^classIntervals.
! !

!HierarchyBranchML class methodsFor: 'class intervals' stamp: 'HAW 3/4/2000 15:43'!
numerateClassesFrom: aClass startingWith: aNumber on: aClassIntervals

	| aClassFrom |	
	aClassFrom _ aNumber + 1.
	aClass subclassesDo:
		[ :aSubClass |
		aClassFrom _ self numerateClassesFrom: aSubClass startingWith: aClassFrom on: aClassIntervals.].

	aClassIntervals at: aClass put: (ClassInterval from: aNumber to: aClassFrom).
	^aClassFrom.
! !


!HierarchyBranchML class methodsFor: 'method lookup' stamp: 'HAW 3/4/2000 15:57'!
compiledMethodFor: aSelector of: aClass

	| classInterval methodFinder |

	classInterval _ self classIntervalFor: aClass.
	methodFinder _ self methodFinderFor: aSelector.

	^methodFinder compiledMethodFor: classInterval.! !

!HierarchyBranchML class methodsFor: 'method lookup' stamp: 'HAW 5/22/2001 09:34'!
lookupMethod: aSelector class: aClass

	| messageImplementationCollection classNumber |

	messageImplementationCollection _ self selectorImplementationsFor: aSelector.
	classNumber _ (self classIntervalFor: aClass) from.
	messageImplementationCollection do: [ :aMessageImplementation |
		(aMessageImplementation includes: classNumber) ifTrue: [ ^aMessageImplementation method. ].
	].

	^nil.
! !


!HierarchyBranchML class methodsFor: 'selector implementations statistics' stamp: 'HAW 5/22/2001 10:17'!
branches

	| branches size assoc |

	branches _ Dictionary new.
	self selectorImplementations associationsDo: [ :anAssociation | 
		size _ anAssociation value size.
		assoc _ branches at: size ifAbsent: [
			branches at: size put: (Association key:0 value: OrderedCollection new).].
		assoc key: assoc key + 1.
		assoc value add: (anAssociation key).
	].

	^branches.! !


!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 10:06'!
testBothDirections

	self testFromMethodDictionaryToSelectorImplementations.
	self testFromSelectorImplementationsToMethodDictionary.! !

!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 10:05'!
testFromMethodDictionaryToSelectorImplementations

	self testMethodsForBehavior: Object.! !

!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 10:05'!
testFromSelectorImplementationsToMethodDictionary

	self selectorImplementations associationsDo: [ :anAssociation |
		self testMethodFor: anAssociation key inMessageImplementationCollection: anAssociation value.
	].! !

!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 09:46'!
testMethodFor: aSelector inMessageImplementation: aMessageImplementation

	| aBehavior |
	aMessageImplementation from to: (aMessageImplementation to-1) do: [ :aNumber |
		aBehavior _ self behaviorFor: aNumber.
		(aBehavior lookupMethod: aSelector)==(aMessageImplementation method) ifFalse: [
			(aSelector==#DoIt and: [aBehavior==UndefinedObject]) ifFalse: [
				self error: 'Error en ', aSelector printString, ' en clase ', aBehavior printString.]. ].
	].! !

!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 09:23'!
testMethodFor: aSelector inMessageImplementationCollection: aMessageImplementationCollection
	
	aMessageImplementationCollection do: [ :aMessageImplementation |
		self testMethodFor: aSelector inMessageImplementation: aMessageImplementation ].! !

!HierarchyBranchML class methodsFor: 'test selector implementations' stamp: 'HAW 5/22/2001 09:44'!
testMethodsForBehavior: aBehavior

	| selector |

	aBehavior methodDictionary associationsDo: [ :anAssociation |
		selector _ anAssociation key.
		(self lookupMethod: selector class: aBehavior)==(anAssociation value) ifFalse: [
			(selector==#DoIt and: [aBehavior==UndefinedObject]) ifFalse: [
			self error: 'Error de ', selector printString, ' en clase ', aBehavior printString.]. ].		 
	].

	aBehavior subclassesDo: [ :aSubclass |
		self testMethodsForBehavior: aSubclass ].! !


!HierarchyBranchML class methodsFor: 'printing' stamp: 'HAW 7/17/2001 09:02'!
printBranchesOn: aStream

	| branches |

	branches _ self branches.
	branches keys asSortedCollection do: [ :aNumberOfImpl | 
		aStream nextPutAll: aNumberOfImpl printString;
			nextPutAll: ', ';
			nextPutAll: (branches at: aNumberOfImpl) key printString;
			cr. ].! !


HierarchyBranchML initialize!


HierarchyBranchML subclass: #HierarchyBranchWithDicML
	instanceVariableNames: ''
	classVariableNames: 'ImplementationThreadshold SelectorImplementationsWithDic '
	poolDictionaries: ''
	category: 'Thesis-Hierarchy Branch'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HierarchyBranchWithDicML class
	instanceVariableNames: ''!

!HierarchyBranchWithDicML class methodsFor: 'testing' stamp: 'HAW 6/10/2001 20:06'!
numberOfDictionaries

	^self selectorImplementationsWithDic count: [ :aCollection | aCollection class=Dictionary ].! !

!HierarchyBranchWithDicML class methodsFor: 'testing' stamp: 'HAW 6/11/2001 00:59'!
numberOfDictionaryEntries

	^self selectorImplementationsWithDic inject: 0 into: [ :valor :dic |
		dic class=Dictionary ifTrue: [
			valor _ valor + dic size. ].
		valor. ]! !

!HierarchyBranchWithDicML class methodsFor: 'testing' stamp: 'HAW 6/10/2001 20:03'!
numberOfSortedCollections

	^self selectorImplementationsWithDic count: [ :aCollection | aCollection class=SortedCollection ].! !


!HierarchyBranchWithDicML class methodsFor: 'threadshold' stamp: 'HAW 6/26/2001 09:14'!
implementationThreadshold

	^ImplementationThreadshold.
		

	! !

!HierarchyBranchWithDicML class methodsFor: 'threadshold' stamp: 'HAW 6/26/2001 09:14'!
implementationThreadshold: aNumber

	ImplementationThreadshold _ aNumber.
		

	! !


!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 5/29/2001 13:02'!
addAsDictionary: aSelectorCollection
	
	aSelectorCollection do: [ :selector |
		SelectorImplementationsWithDic at: selector put: (self createMethodDictionaryFor: selector).].
	
		

	! !

!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 5/29/2001 12:37'!
addAsSortedCollection: aSelectorCollection
	
	aSelectorCollection do: [ :selector |
		SelectorImplementationsWithDic at: selector put: (super selectorImplementationsFor: selector).].
	
		

	! !

!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 6/10/2001 18:54'!
createMethodDictionaryFor: aSelector

	| implementations methodDictionary | 

	methodDictionary _ Dictionary new.
	implementations _ self selectorImplementationsFor: aSelector.
	implementations do: [ :messageImplementationBranch |
		messageImplementationBranch from to: (messageImplementationBranch to-1) do: [:classNumber |
			methodDictionary at: (self classFor: classNumber) 
				put: (messageImplementationBranch method).].
	].

	methodDictionary rehash.
	^methodDictionary! !

!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 6/10/2001 19:24'!
initialize

	super initialize.
	self initializeSelectorsImplementationsWithDic.
	Smalltalk garbageCollect.! !

!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 6/10/2001 20:05'!
initializeSelectorsImplementationsWithDic

	| branches selectors |

	SelectorImplementationsWithDic _ Dictionary new.
	branches _ self branches.
	branches associationsDo: [ :association |
		selectors _ association value value.
		association key <= self implementationThreadshold ifTrue: [
			self addAsSortedCollection: selectors.
		]
		ifFalse: [
			self addAsDictionary: selectors.
		].
	].	
		

	! !

!HierarchyBranchWithDicML class methodsFor: 'initialization' stamp: 'HAW 5/29/2001 12:53'!
selectorImplementationsWithDic

	^SelectorImplementationsWithDic! !


HierarchyBranchWithDicML initialize!


ClassInterval subclass: #MessageImplementationBranch
	instanceVariableNames: 'method '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Hierarchy Branch'!

!MessageImplementationBranch methodsFor: 'method access' stamp: 'HAW 5/17/2001 09:16'!
method
	^method! !

!MessageImplementationBranch methodsFor: 'method access' stamp: 'HAW 5/17/2001 09:16'!
method: aMethod
	method _ aMethod.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageImplementationBranch class
	instanceVariableNames: ''!

!MessageImplementationBranch class methodsFor: 'creation' stamp: 'HAW 5/17/2001 09:25'!
classInterval: aClassInterval method: aMethod

	^self new
		from: aClassInterval from;
		to: aClassInterval to;
		method: aMethod;
		yourself.! !
