Object subclass: #ConfigMLInterpreterProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Statistics Support'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ConfigMLInterpreterProxy class
	instanceVariableNames: ''!

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 5/3/2001 09:25'!
runPrimitiveMessageToMethodLookupStrategy: aMessage
	<primitive: 573>
	self error: 'Error running primitive #runPrimitiveMessageToMethodLookupStrategy:'. ! !

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 5/3/2001 09:25'!
runPrimitiveMessageToMethodLookupStrategy: aMessage with: aCollaborator
	<primitive: 573>
	self error: 'Error running primitive #runPrimitiveMessageToMethodLookupStrategy:with:'. ! !

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 1/9/2001 09:30'!
runPrimitiveStartTest: aName
	<primitive: 570>
	self error: 'Error running primitive #runPrimitiveStartTest:'. ! !

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 6/16/2001 11:04'!
runPrimitiveStopTest: aStatsPrintingType

	<primitive:571>
	self error: 'Error running primitive #runPrimitiveStopTest'.! !

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 6/12/2001 10:42'!
runPrimitiveUseCacheMethodLookup: aMethodLookupKey initializationArray: anArrayOrNil cacheInitializationArray: anotherInitializationArrayOrNil

	<primitive: 573>
	self error: 'Error running primitive #runPrimitiveUseMethodLookup:'. ! !

!ConfigMLInterpreterProxy class methodsFor: 'interpreter comunications' stamp: 'HAW 5/10/2001 08:55'!
runPrimitiveUseMethodLookup: aMethodLookupKey initializationArray: anArrayOrNil
	<primitive: 572>
	self error: 'Error running primitive #runPrimitiveUseMethodLookup:'. ! !


Object subclass: #MessageSentAnalizer
	instanceVariableNames: 'messageDictionary analizedSet totalMessagesSend '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Statistics Support'!

!MessageSentAnalizer methodsFor: 'private' stamp: 'HAW 11/29/1999 21:25'!
basicAnalize
	| selector selectorStatistics |
	totalMessagesSend _ 0.
	analizedSet _ Set new.
	messageDictionary associationsDo: [ :association |
		"Gets the selector"
		selector _ association key allButFirst asSymbol.
		selectorStatistics _ SelectorStatistics on: selector.
		"Sets the number of implementators"
		selectorStatistics numberOfImplementators: (Smalltalk allImplementorsOf: selector) size.	
		"Saves the number of sents..."
		selectorStatistics numberOfSends: ((association value) inject:0 into: [ :preValue :newValue | preValue _ preValue + newValue]).
		totalMessagesSend _ totalMessagesSend + selectorStatistics numberOfSends.
		analizedSet add: selectorStatistics.].
! !

!MessageSentAnalizer methodsFor: 'private' stamp: 'HAW 11/29/1999 22:04'!
numberOfSendsFor: numberOfImplementators with: aBooleanBlock
	^ analizedSet inject: 0 into: [ :preValue :messageStatistics |
		(aBooleanBlock value: numberOfImplementators value: messageStatistics numberOfImplementators)
		ifTrue: [preValue _ preValue + messageStatistics numberOfSends.].
		preValue.].
! !

!MessageSentAnalizer methodsFor: 'private' stamp: 'HAW 11/29/1999 21:49'!
readFile: aFileName
	| stream |
	stream _ ReferenceStream fileNamed: aFileName.
	messageDictionary _ Dictionary new.
	messageDictionary _ stream next.
	stream close. ! !


!MessageSentAnalizer methodsFor: 'processing' stamp: 'HAW 11/30/1999 17:22'!
analize: aFileName
	self readFile: aFileName.
	self basicAnalize.

	! !


!MessageSentAnalizer methodsFor: 'printing' stamp: 'HAW 11/29/1999 22:05'!
print: numberOfImplementators with: messageSends on: aStream
		aStream nextPutAll: 'Messages Send with '; 
			nextPutAll: (numberOfImplementators asString);
			nextPutAll: ' implementation(s): ';
			nextPutAll: (messageSends asString);
			nextPutAll: ', ';
			nextPutAll: ((messageSends*100/totalMessagesSend) asInteger asString);
			nextPutAll: '%';
			cr.
! !

!MessageSentAnalizer methodsFor: 'printing' stamp: 'HAW 11/29/1999 21:31'!
printOn: aStream
	| messageSends |
	1 to: 6 do: [ :numberOfImplementators |
		messageSends _ self numberOfSendsFor: numberOfImplementators with: [ :a :b | a=b ].
		self print: numberOfImplementators with: messageSends on: aStream.].

	messageSends _ self numberOfSendsFor: 6 with: [ :a :b | a<b ].
	self print: 6 with: messageSends on: aStream.! !

!MessageSentAnalizer methodsFor: 'printing' stamp: 'HAW 11/29/1999 21:33'!
printResult
	| string |
	string _ String streamContents: [ :aStream |
		self printOn: aStream. ].
	Transcript show: string.
! !

!MessageSentAnalizer methodsFor: 'printing' stamp: 'HAW 11/30/1999 16:58'!
printResultAsCsv: aFileName
	| string |
	string _ String streamContents: [ :aStream | self printResultAsCsv: aFileName on: aStream.
		aStream cr. ].

	Transcript show: string.! !

!MessageSentAnalizer methodsFor: 'printing' stamp: 'HAW 11/30/1999 16:57'!
printResultAsCsv: aFileName on: aStream
	| messageSends |
	aStream nextPutAll: aFileName.
	1 to: 6 do: [ :numberOfImplementators |
		messageSends _ self numberOfSendsFor: numberOfImplementators with: [ :a :b | a=b ].
		aStream 
			nextPutAll: ',';
			nextPutAll: (numberOfImplementators asString);
			nextPutAll: ',';
			nextPutAll: ((messageSends*100/totalMessagesSend) asInteger asString).].

	messageSends _ self numberOfSendsFor: 6 with: [ :a :b | a<b ].
	aStream 
		nextPutAll: ',7,';
		nextPutAll: ((messageSends*100/totalMessagesSend) asInteger asString).
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageSentAnalizer class
	instanceVariableNames: ''!

!MessageSentAnalizer class methodsFor: 'as yet unclassified' stamp: 'HAW 11/29/1999 20:48'!
fileNamed: aString
	^ super fileNamed: aString.! !


Object subclass: #SelectorStatistics
	instanceVariableNames: 'selector numberOfImplementators numberOfSends '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Statistics Support'!

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:07'!
numberOfImplementators
	^numberOfImplementators.! !

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:09'!
numberOfImplementators: aNumber
	numberOfImplementators _ aNumber.! !

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:09'!
numberOfSends
	^numberOfSends.! !

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:09'!
numberOfSends: aNumber
	numberOfSends _ aNumber.! !

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:07'!
selector
	^selector.! !

!SelectorStatistics methodsFor: 'accessing' stamp: 'HAW 11/29/1999 21:07'!
selector: aSelector
	selector _ aSelector.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SelectorStatistics class
	instanceVariableNames: ''!

!SelectorStatistics class methodsFor: 'as yet unclassified' stamp: 'HAW 11/29/1999 21:59'!
on: aSelector
	^super new selector: aSelector.! !


Object subclass: #ThesisBenchmarks
	instanceVariableNames: ''
	classVariableNames: 'StatsPrintingType '
	poolDictionaries: ''
	category: 'Thesis-Statistics Support'!

!ThesisBenchmarks methodsFor: 'caching initalization blocks' stamp: 'HAW 8/7/2001 09:14'!
globalLookupCacheInitializationBlock

	^ Array 
		with: (Association key: 'methodCacheEntries:' value: 512).	! !


!ThesisBenchmarks methodsFor: 'method lookup initialization blocks' stamp: 'HAW 6/11/2001 02:13'!
dtsWithClassesInitializationArray

	^ Array 
		with: (Association key: 'selectorsDictionary:' value: DTSWithClassesMLProxy selectorsDictionary).! !

!ThesisBenchmarks methodsFor: 'method lookup initialization blocks' stamp: 'HAW 6/11/2001 02:14'!
hierarchyBranchInitializationArray

	^ Array 
			with: (Association key: 'classIntervals:' value: HierarchyBranchML classIntervals)
			with: (Association key: 'selectorsImplementations:' value: HierarchyBranchML selectorImplementations).! !

!ThesisBenchmarks methodsFor: 'method lookup initialization blocks' stamp: 'HAW 6/11/2001 02:15'!
hierarchyBranchWithDicInitializationArray

	^ Array 
			with: (Association key: 'classIntervals:' value: HierarchyBranchWithDicML classIntervals)
			with: (Association key: 'selectorsImplementations:' value: HierarchyBranchWithDicML selectorImplementationsWithDic)
			with: (Association key: 'sortedCollection:' value: SortedCollection).! !


!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 7/19/2001 09:32'!
runAllTestsUsingGLCWithDTS

"	FullDictionaryML selectDTS."
	self runAllTestsWithMethodLookupKey: 2
		initializationArray: nil
		cacheInitializationArray: self globalLookupCacheInitializationBlock. ! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 6/12/2001 10:48'!
runAllTestsUsingGLCWithDTSWithClasses

	self runAllTestsWithMethodLookupKey: 6
		initializationArray: self dtsWithClassesInitializationArray
		cacheInitializationArray: self globalLookupCacheInitializationBlock. ! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 7/19/2001 09:06'!
runAllTestsUsingGLCWithFullDictionaries

	FullDictionaryML selectFullDictionary.
	self runAllTestsWithMethodLookupKey: 11
		initializationArray: nil
		cacheInitializationArray: self globalLookupCacheInitializationBlock. 
	FullDictionaryML selectDTS.! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 6/12/2001 10:48'!
runAllTestsUsingGLCWithHB

	self runAllTestsWithMethodLookupKey: 7
		initializationArray: self hierarchyBranchInitializationArray
		cacheInitializationArray: self globalLookupCacheInitializationBlock. ! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 6/12/2001 10:48'!
runAllTestsUsingGLCWithHBWithDic

	self runAllTestsWithMethodLookupKey: 8
		initializationArray: self hierarchyBranchWithDicInitializationArray
		cacheInitializationArray: self globalLookupCacheInitializationBlock. ! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 15:51'!
runAllTestsUsingHBCacheCircularAddCachingStrategy

	self runAllTestsWithMethodLookupKey: 14
		initializationArray: self hierarchyBranchInitializationArray
		cacheInitializationArray: nil. 
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 15:52'!
runAllTestsUsingHBCachingWithHBML

	self error: 'Invalid'.
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 11:05'!
runAllTestsUsingHBCachingWithHBWithDicML

	self error: 'Can''t use HierarchyBranchCaching with HierarchyBranchWitchDic'.
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 15:51'!
runAllTestsUsingHBEraseAllCachingStrategy

	self runAllTestsWithMethodLookupKey: 12
		initializationArray: self hierarchyBranchInitializationArray
		cacheInitializationArray: nil. 
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 15:51'!
runAllTestsUsingHBGlobalCircularAddCachingStrategy

	self runAllTestsWithMethodLookupKey: 13
		initializationArray: self hierarchyBranchInitializationArray
		cacheInitializationArray: nil. 
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/11/2001 16:25'!
runAllTestsUsingHBOneEntryCachingStrategy

	self runAllTestsWithMethodLookupKey: 15
		initializationArray: self hierarchyBranchInitializationArray
		cacheInitializationArray: nil. 
! !

!ThesisBenchmarks methodsFor: 'test support using CacheML' stamp: 'HAW 8/9/2001 09:06'!
runAllTestsUsingSLCWithDTS

	self runAllTestsWithMethodLookupKey: 9
		initializationArray: nil
		cacheInitializationArray: nil. ! !


!ThesisBenchmarks methodsFor: 'test support using ML' stamp: 'HAW 6/11/2001 02:14'!
runAllTestsUsingDTSWithClassesML

	self runAllTestsWithMethodLookupKey: 3 
		initializationArray: self dtsWithClassesInitializationArray.! !

!ThesisBenchmarks methodsFor: 'test support using ML' stamp: 'HAW 7/19/2001 09:20'!
runAllTestsUsingDispatchTableSearchML

"	FullDictionaryML selectDTS."
	self runAllTestsWithMethodLookupKey: 1.! !

!ThesisBenchmarks methodsFor: 'test support using ML' stamp: 'HAW 7/19/2001 09:05'!
runAllTestsUsingFullDictionariesML

	FullDictionaryML selectFullDictionary.
	self runAllTestsWithMethodLookupKey: 10.
	FullDictionaryML selectDTS.! !

!ThesisBenchmarks methodsFor: 'test support using ML' stamp: 'HAW 6/11/2001 02:15'!
runAllTestsUsingHierarchyBranchML

	self runAllTestsWithMethodLookupKey: 4
		initializationArray: self hierarchyBranchInitializationArray.! !

!ThesisBenchmarks methodsFor: 'test support using ML' stamp: 'HAW 6/11/2001 02:15'!
runAllTestsUsingHierarchyBranchWithDicML

	self runAllTestsWithMethodLookupKey: 5
		initializationArray: self hierarchyBranchWithDicInitializationArray.! !


!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/26/2001 09:01'!
perform: aSymbol times: aNumber

	aNumber timesRepeat: [ self perform: aSymbol ].
	Smalltalk beep.
	Smalltalk snapshot: false andQuit: true.
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:24'!
runAllTests
	self runAllTestsWithMethodLookupKey: 0.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:24'!
runAllTests: aTimesNumber
	self runAllTests: aTimesNumber withMethodLookupKey: 0.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 5/10/2001 08:51'!
runAllTests: aTimesNumber withMethodLookupKey: aMethodLookupKey
	self runAllTests: aTimesNumber withMethodLookupKey: aMethodLookupKey initializationArray: nil.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 5/10/2001 08:49'!
runAllTests: aTimesNumber withMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil
	| categorySelectors |
	categorySelectors _ ThesisBenchmarks organization listAtCategoryNamed: #tests.
	categorySelectors do: [ :selector | 
		self runTest: selector times: aTimesNumber withMethodLookupKey: aMethodLookupKey 
			initializationArray: anArrayOrNil. ].

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/12/2001 10:47'!
runAllTests: aTimesNumber withMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil cacheInitializationArray: anotherArrayOrNil

	| categorySelectors |
	categorySelectors _ ThesisBenchmarks organization listAtCategoryNamed: #tests.
	categorySelectors do: [ :selector | 
		self runTest: selector times: aTimesNumber withMethodLookupKey: aMethodLookupKey 
			initializationArray: anArrayOrNil cacheInitializationArray: anotherArrayOrNil. ].

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/18/2001 00:04'!
runAllTestsUsingAllML

	| categorySelectors |
	categorySelectors _ ThesisBenchmarks organization listAtCategoryNamed: 'test support using CacheML' asSymbol.
	categorySelectors do: [ :selector | self perform: selector. ].

	categorySelectors _ ThesisBenchmarks organization listAtCategoryNamed: 'test support using ML' asSymbol.
	categorySelectors do: [ :selector | self perform: selector. ].
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:26'!
runAllTestsWithMethodLookupKey: aMethodLookupKey
	^self runAllTests: 1 withMethodLookupKey: aMethodLookupKey

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 5/10/2001 08:48'!
runAllTestsWithMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil
	^self runAllTests: 1 withMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/13/2001 08:36'!
runAllTestsWithMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil cacheInitializationArray: anotherArrayOrNil

	^self runAllTests: 1 
		withMethodLookupKey: aMethodLookupKey 
		initializationArray: anArrayOrNil
		cacheInitializationArray: anotherArrayOrNil.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:20'!
runInteractiveTest
	| name | 
	name _ FillInTheBlank request: 'Test name?'.
	self startTest: name.
	self error: 'Start the test. Select Procced to ended'.
	self stopTest.! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 11/17/1999 17:19'!
runTest: testNameSymbol
	self runTest: testNameSymbol times: 1.
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:27'!
runTest: testNameSymbol times: aCounter
	self runTest: testNameSymbol times: aCounter withMethodLookupKey: 0.
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 5/10/2001 08:54'!
runTest: testNameSymbol times: aCounter withMethodLookupKey: aMethodLookupKey

	self runTest: testNameSymbol times: aCounter withMethodLookupKey: aMethodLookupKey initializationArray: nil.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 5/10/2001 08:53'!
runTest: testNameSymbol times: aCounter withMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil

	ConfigMLInterpreterProxy runPrimitiveUseMethodLookup: aMethodLookupKey initializationArray: anArrayOrNil.
	self startTest: testNameSymbol asString.
	1 to: aCounter do: [ :index | self perform: testNameSymbol.].
	self stopTest.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/12/2001 10:42'!
runTest: testNameSymbol times: aCounter withMethodLookupKey: aMethodLookupKey initializationArray: anArrayOrNil cacheInitializationArray: anotherArrayOrNil

	ConfigMLInterpreterProxy runPrimitiveUseCacheMethodLookup: aMethodLookupKey initializationArray: anArrayOrNil cacheInitializationArray: anotherArrayOrNil.
	self startTest: testNameSymbol asString.
	1 to: aCounter do: [ :index | self perform: testNameSymbol.].
	self stopTest.

! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 1/9/2001 09:28'!
runTest: testNameSymbol withMethodLookupKey: aMethodLookupKey
	self runTest: testNameSymbol times: 1 withMethodLookupKey: aMethodLookupKey.
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/26/2001 09:38'!
startTest: testName
"	Smalltalk garbageCollect."
	ConfigMLInterpreterProxy runPrimitiveStartTest: testName
! !

!ThesisBenchmarks methodsFor: 'test support' stamp: 'HAW 6/16/2001 11:04'!
stopTest
	ConfigMLInterpreterProxy runPrimitiveStopTest: self statsPrintingType.

! !


!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 17:16'!
testCompiler
	| sourceCode compiler methodNode |
	sourceCode _ ThesisBenchmarks class sourceCodeAt: #LongMethod.
	compiler _ ThesisBenchmarks class compilerClass new.
	methodNode _ compiler compile: sourceCode
		in: ThesisBenchmarks class
		notifying: nil
		ifFail: [self error: 'Error Compiling #LongMethod'].
	^methodNode sourceMap.

! !

!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 17:31'!
testDecompiler
	| decompiler method |
	method _ ThesisBenchmarks class compiledMethodAt: #LongMethod.
	decompiler _ ThesisBenchmarks class decompilerClass new.
	^decompiler decompile: #LongMethod
		in: ThesisBenchmarks class
		method: method.

! !

!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 18:23'!
testFileOut
	| fileStream |
	FileDirectory deleteFilePath: ThesisBenchmarks FileInOutName.
	fileStream _ FileStream fileNamed: ThesisBenchmarks FileInOutName.
	AbstractSound fileOutOn: fileStream.
	fileStream close.
! !

!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 18:31'!
testPrintHierarchy
	| stringHierarchy |
	stringHierarchy _ Number printHierarchy.
	Transcript show: stringHierarchy.! !

!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 13:24'!
testRestoreDisplay
	ScheduledControllers restore.
	ScheduledControllers activeController view emphasize! !

!ThesisBenchmarks methodsFor: 'tests' stamp: 'HAW 11/18/1999 16:07'!
testTranscriptShow
	Transcript clear.
	Transcript show: 'Hello world!!'; cr.
! !


!ThesisBenchmarks methodsFor: 'initialization' stamp: 'HAW 6/16/2001 11:04'!
initialize

	self statsPrintingType: 1.! !


!ThesisBenchmarks methodsFor: 'stats printing type' stamp: 'HAW 6/17/2001 18:23'!
statsPrintingType

	^self class statsPrintingType.! !

!ThesisBenchmarks methodsFor: 'stats printing type' stamp: 'HAW 6/17/2001 18:23'!
statsPrintingType: aValue

	self class statsPrintingType: aValue.! !


!ThesisBenchmarks methodsFor: 'not used test' stamp: 'HAW 11/18/1999 15:38'!
testFileIn
	|fileStream|
	fileStream _ FileStream readOnlyFileNamed: ThesisBenchmarks FileInOutName.
	fileStream fileIn.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ThesisBenchmarks class
	instanceVariableNames: ''!

!ThesisBenchmarks class methodsFor: 'constants' stamp: 'HAW 10/16/2000 09:01'!
FileInOutName
	^ '\Development\thesis\AbstractSound.st'! !

!ThesisBenchmarks class methodsFor: 'constants' stamp: 'HAW 11/18/1999 16:47'!
LongMethod
	"This method is for test porpouses only.
	 Used by testCompiler and testDecompiler."

	| var1 var2 var3 var4 var5 var6 |
	var1 _ 'Hello World!!'.
	Transcript show: var1; cr.
	var2 _ 1.
	var3 _ 100.
	var2 to: var3 do: [ :index | var1 _ var1 + index asString ].
	var4 _ var1 size.
	var4 _ var4 factorial.

	var5 _ var2=10.
	var5 ifTrue: [ var2 _ 'True'. ] 
		  ifFalse: [ var2 _ 'False' ].

	[var2<20] whileTrue: [ 
		var2 _ var2 + 1.
		var6 _ 'Bye now'.
		Transcript show: var6. ].

	var6 _ 10 factorial.
	var1 _ 0.
	[var6>11 factorial] whileFalse: [
		var6 _ var6 - 1.
		var1 _ var1 + 1.
		var1%10=0 ifTrue: [ Transcript show: var6 asString].].

	^false.


		! !


!ThesisBenchmarks class methodsFor: 'stats printing type' stamp: 'HAW 6/17/2001 18:22'!
statsPrintingType

	^StatsPrintingType! !

!ThesisBenchmarks class methodsFor: 'stats printing type' stamp: 'HAW 6/17/2001 18:22'!
statsPrintingType: aType

	StatsPrintingType _ aType.! !
